// header file for Node.cpp

#ifndef __NODE_H
#define __NODE_H

#include "Packet.h"

//node types
#define	SOURCE	'1'
#define	SINK	'2'

class Node 
{
public:
    //Constructors, Get, Set etc.
    Node();
    ~Node();
    
    char getType();
    void setType(char typ);
    
    static double getPropagationDelay();
    static double getProcessingDelay();
    static double getDuration();
    static double getPacketRate();
    static double getBitRate();
    static double getDataPacketSize();
    static double getDataOverhead();
    static double getACKSize();
    static char getARQMethod();    
    static void setPropagationDelay(double pD);
    static void setProcessingDelay(double pD);
    static void setDuration(double dur);
    static void setPacketRate(double pR);
    static void setBitRate(double bR);
    static void setDataPacketSize(double dPS);
    static void setDataOverhead(double dO);
    static void setACKSize(double aS);
    static void setARQMethod(char aM);
    
    void reset();
    //Packet generation methods
    int generatePackets();
    int sendPackets();		
    
private:
    //Data Members
    static double propagationDelay;
    static double processingDelay;
    static double duration;
    static double packetRate;
    static double bitRate;
    static double dataPacketSize;
    static double dataOverhead;
    static double ackSize;
    static char arqMethod;
    
    char type;
    int sequenceNumber;    
    PacketQueue PacketBuffer;
    PacketQueue PendingBuffer;
    
public:
    PacketQueue OutgoingPacketQueue;
    PacketQueue IncomingPacketQueue;
};
#endif
