#ifndef __PACKET_H
#define __PACKET_H

#define DATA	'1'
#define ACK	'2'
#define NAK	'3'

class Packet 
{
public:
    Packet();
    ~Packet();
    
    Packet* clone();
    char getType();
    char getSource();
    char getDestination();
    char getTransmissionStatus();
    int getSequenceNumber();
    double getSize();
    double getOverhead();
    double getCreationTime();
    double getReadyToSendTime();
    void setType(char typ);
    void setSource(char src);
    void setDestination(char dst);
    void setTransmissionStatus(char trSt);
    void setSequenceNumber(int sn);
    void setSize(double sz);
    void setOverhead(double oh);
    void setCreationTime(double ct);
    void setReadyToSendTime(double rtst);
    
private:
    char type;
    char source;
    char destination;
    char transmissionStatus;
    int sequenceNumber;
    double size;
    double overhead;
    double creationTime;
    double readyToSendTime;
};

class PacketQueue
{
public:
    PacketQueue();
    ~PacketQueue();
    
    int getLength();
    double getCreationTime(int index);
    double getReadyToSendTime(int index);
    double getSize(int index);
    int  getSequenceNumber(int index);
    void setTransmissionStatus(int index, char trSt);
    Packet* dequeuePacket(int index);
    void enqueuePacket(Packet* pkt);
    void clear();
    
private:
    int length;
    Packet** Packets;
};
#endif
